----------------------------------------------------------------------------------
--
-- scenetemplate.lua
--
----------------------------------------------------------------------------------

local storyboard = require( "storyboard" )
local scene = storyboard.newScene()

local myscreenGroup

local widget = require("widget")
require "extras"

local group2


--local ads = require "ads"

--typeOfPlay
----------------------------------------------------------------------------------
-- 
--	NOTE:
--	
--	Code outside of listener functions (below) will only be executed once,
--	unless storyboard.removeScene() is called.
-- 
---------------------------------------------------------------------------------

--local sndNoMatch = audio.loadSound("audio/nomatch.mp3")
--local sndMatch = audio.loadSound("audio/match.mp3")
--local sndWinner = audio.loadSound("audio/winner.mp3")


	

local function changeMusic(e)
        local x
        local y
        x = btnSound.x
        y = btnSound.y
        btnSound:removeEventListener("tap",changeMusic)
        myscreenGroup:remove(btnSound)

        if (withBackgroundMousic==true) then
            withBackgroundMousic = false
            btnSound = display.newImageRect(menuScreen.soundPlay, menuScreen.soundbuttonDimention, menuScreen.soundbuttonDimention)

            
            audio.stop()
        else 
            withBackgroundMousic = true
            btnSound = display.newImageRect(menuScreen.soundPause, menuScreen.soundbuttonDimention, menuScreen.soundbuttonDimention)
            
            playLoopSound( theme_sound,1, -1 , 0.3)

        end

        btnSound.x = x
        btnSound.y = y
        myscreenGroup:insert(btnSound)
        btnSound:addEventListener("tap",changeMusic)
end

local function gotomenu(e)
    storyboard.gotoScene( "menu", {effect="fade"} )
end
		
local function restartLevel(e)
   -- currentLevel = e.target.idx
    storyboard.purgeScene("gamepuzzle")
    storyboard.removeScene("gamepuzzle")
    storyboard.gotoScene( "gamepuzzle", {effect="fade"} )

end

local function gotoNextLevel(e)
    currentLevel = currentLevel + 1
    currentStage = stageToGo
    storyboard.purgeScene("gamepuzzle")
    storyboard.removeScene("gamepuzzle")
    storyboard.gotoScene( "gamepuzzle", {effect="fade"} )

end


---------------------------------------------------------------------------------
-- BEGINNING OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- Called when the scene's view does not exist:
function scene:createScene( event )
	local group = self.view
	myscreenGroup = group

	local prior_scene = storyboard.getPrevious()
	storyboard.purgeScene( prior_scene )
	
	storyboard.purgeAll()


	loadPrefs()


	if (withBackgroundMousic==true) then
        btnSound = display.newImageRect("images/buttons/btn_sound-sheet0.png", interface[1].soundButtonDimention, interface[1].soundButtonDimention )
        audio.stop()
        playLoopSound( theme_sound,1, -1 , 0.3)
    else 
        btnSound = display.newImageRect("images/buttons/btn_sound-sheet1.png", interface[1].soundButtonDimention, interface[1].soundButtonDimention )
        audio.stop()
    end

    btnSound.x = display.contentWidth - interface[1].soundButtonDimention--100--centerX
    btnSound.y = topbarButtons-- 20 -- display.contentHeight - 50
    myscreenGroup:insert(btnSound)
    --group:insert(btnSound)
    --btnSound:addEventListener("tap",changeMusic)
    btnSound:toFront()
    btnSound:addEventListener("tap",changeMusic)

    local myYDimention = display.contentCenterY + interface[1].downButtonsDimention
    local retry = display.newImageRect(interface[1].backbutton, interface[1].soundButtonDimention, interface[1].soundButtonDimention )
    retry.x = interface[1].btnMenuX
    retry.y = topbarButtons
    myscreenGroup:insert( retry )
    --retry.xScale,retry.yScale=2,2
    retry.alpha=1
    retry:addEventListener("tap",gotomenu)

     local imagesign =  display.newImageRect( interface[1].welldone, 700, 756 )
	imagesign.x = display.contentCenterX
	imagesign.y = display.contentCenterY - 25
	imagesign:toFront()
	myscreenGroup:insert( imagesign )

    --Buttons
    --local myYButtonDimention = display.contentCenterY + 400

	local restart = display.newImageRect(interface[1].restart, 150, 150 )
	restart.x = imagesign.x - 120
	restart.y = imagesign.y + 90
	myscreenGroup:insert( restart )
	--retry.xScale,retry.yScale=2,2
	restart.alpha=1
	restart:addEventListener("tap",restartLevel)
    


    local myYDimention = myYButtonDimention
	local nextLevel = display.newImageRect(interface[1].gamePlay, 150, 150 )
	nextLevel.x = imagesign.x + 120
	nextLevel.y = imagesign.y + 90
	myscreenGroup:insert( nextLevel )
	--retry.xScale,retry.yScale=2,2
	nextLevel.alpha=1
	nextLevel:addEventListener("tap",gotoNextLevel)




	 
end


-- Called immediately after scene has moved onscreen:
function scene:enterScene( event )
	local group = self.view
	group2 = group
	-----------------------------------------------------------------------------
		
	--	INSERT code here (e.g. start timers, load audio, start listeners, etc.)
	
	-----------------------------------------------------------------------------
	
	--print("Enterd");
	--local showAds = math.random( 0, 1 )
	--if showAds == 0 then
		
	--showAdd = true

	--[[
		if ( isSimulator or not testNetworkConnection() ) then
			print("on simulator or no network connection, and therefore, no fullscreen ads")
		else
				local function adListener( event )
					if event.isError then
						-- Failed to receive an ad.
					end
				end

				ads.init( "admob", stats[1].admobid, adListener )
				ads.show( "interstitial", { x=0, y=0 } )
		end
	]]
	--end 

	
end


-- Called when scene is about to move offscreen:
function scene:exitScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. stop timers, remove listeners, unload sounds, etc.)
	
	-----------------------------------------------------------------------------
	
end


-- Called prior to the removal of scene's "view" (display group)
function scene:destroyScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. remove listeners, widgets, save state, etc.)
	
	-----------------------------------------------------------------------------
	
end


---------------------------------------------------------------------------------
-- END OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- "createScene" event is dispatched if scene's view does not exist
scene:addEventListener( "createScene", scene )

-- "enterScene" event is dispatched whenever scene transition has finished
scene:addEventListener( "enterScene", scene )

-- "exitScene" event is dispatched before next scene's transition begins
scene:addEventListener( "exitScene", scene )

-- "destroyScene" event is dispatched before view is unloaded, which can be
-- automatically unloaded in low memory situations, or explicitly via a call to
-- storyboard.purgeScene() or storyboard.removeScene().
scene:addEventListener( "destroyScene", scene )

---------------------------------------------------------------------------------

return scene