-----------------------------------------------------------------------------------------
--
-- menu.lua
--
-----------------------------------------------------------------------------------------

-- allow this lua file to be used with storyboards
local storyboard = require "storyboard"
local scene = storyboard.newScene()
local utility = require ("utility")
local math = require ("math")

local physics = require("physics")
local myscreenGroup
local menuIsRunning = true

require "extras"

require "extras"
--rate
local rateit = require("rateit")
  
rateit.setAndroidURL("com.podermltd.Silly_Balls")
rateit.setPlatformName("Android")

--rate

physics.start()
physics.setGravity( 0, 0 )

local retry
local btn_settings
local highScores

local background

local state = "run"
--local playText

local W = display.contentWidth
local H = display.contentHeight
local Cx = W * 0.5
local Cy = H * 0.5
local radius = 64 -- constant on image
local ballColours = { "black", "blue", "red", "green", "gold", "blue", "gold", "red", "green" }
local freeBalls = {}
local tPrevious



local options =
{
	effect = "fade",
	navigation[1].timeForFade,
}

local function goRate()
	rateit.openURL()
end

local function changeMusic(e)
        local x
        local y
        x = btnSound.x
        y = btnSound.y
        btnSound:removeEventListener("tap",changeMusic)
        myscreenGroup:remove(btnSound)

        if (withBackgroundMousic==true) then
            withBackgroundMousic = false
            btnSound = display.newImageRect(interface[1].soundPlay, interface[1].soundButtonDimention, interface[1].soundButtonDimention)

            print("audio.stop()")
            audio.stop()
        else 
            withBackgroundMousic = true
            btnSound = display.newImageRect(interface[1].soundPause, interface[1].soundButtonDimention, interface[1].soundButtonDimention)
            
            playLoopSound( theme_sound,1, -1 , 0.3)

        end

        btnSound.x = x
        btnSound.y = y
        myscreenGroup:insert(btnSound)
        btnSound:addEventListener("tap",changeMusic)
end

local function gotoPlay()
	--storyboard.gotoScene( "level1Storyboard", options)
	state = "leave"
	background.alpha = 0
	storyboard.gotoScene("gamepuzzle",options)

	--storyboard.gotoScene( "gohome2", {effect="fade"} )
end

local function gotoTimeAttack()
	storyboard.gotoScene( "playmenu", options )
end

local function gotoPuzzleMode()
	storyboard.gotoScene( "selectstage", options )
end

-- what to do when the screen loads
function scene:createScene(event)

	storyboard.purgeScene("game")
	storyboard.purgeAll()

	myscreenGroup = self.view
	background = display.newImageRect(interface[1].gameBg, 1080, 1920)
	background.alpha = 1--0.9
	utility.putInCentre(background)  

	--local title = display.newText("SillyBalls!", 0, 0, "Helvetica", 104) 
	--utility.centreObjectX(title)
	--title.anchorY = 0
	--title:translate(0, 120)
	--title:setFillColor( 0, 0, 0 )
	
	--playText = display.newText("PLAY GAME", 0, 0, "Helvetica", 98) 
	--utility.centreObjectX(playText)
	--playText.anchorY = 0
	--playText:translate(0, 480)
	--utility.setColour(playText, 175, 0, 175)
	

	if (withBackgroundMousic==true) then
        btnSound = display.newImageRect("images/buttons/btn_sound-sheet0.png", interface[1].soundButtonDimention, interface[1].soundButtonDimention )
        audio.stop()
        playLoopSound( theme_sound,1, -1 , 0.3)
    else 
        btnSound = display.newImageRect("images/buttons/btn_sound-sheet1.png", interface[1].soundButtonDimention, interface[1].soundButtonDimention )
        audio.stop()
    end
    btnSound.x = display.contentWidth - interface[1].soundButtonDimention--100--centerX
    btnSound.y = topbarButtons-- 20 -- display.contentHeight - 50
    myscreenGroup:insert(btnSound)
    --group:insert(btnSound)
    --btnSound:addEventListener("tap",changeMusic)
    btnSound:toFront()
    btnSound:addEventListener("tap",changeMusic)


    local imagesign =  display.newImageRect( interface[1].menumessage, 700, 756 )
	imagesign.x = display.contentCenterX
	imagesign.y = display.contentCenterY - 65
	imagesign:toFront()
	myscreenGroup:insert( imagesign )

	--timeattackbutton.png
	local timeattackbutton =  display.newImageRect( interface[1].timeattackbutton, 350, 157 )
	timeattackbutton.x = display.contentCenterX
	timeattackbutton.y = display.contentCenterY - 85
	timeattackbutton:toFront()
	timeattackbutton:addEventListener( "tap", gotoTimeAttack )
	myscreenGroup:insert( timeattackbutton )


	local puzzlemode =  display.newImageRect( interface[1].puzzlemode, 350, 157 )
	puzzlemode.x = display.contentCenterX
	puzzlemode.y = display.contentCenterY + 120
	puzzlemode:toFront()
	puzzlemode:addEventListener( "tap", gotoPuzzleMode)
	myscreenGroup:insert( puzzlemode )

	
	

	local rateme =  display.newImageRect( interface[1].rateme, 250, 112 )
	rateme.x = display.contentCenterX
	rateme.y = display.contentCenterY + interface[1].downButtonsDimention
	rateme:toFront()
	rateme:addEventListener( "tap", goRate)
	myscreenGroup:insert( rateme )



	tPrevious = system.getTimer() 
end

local function newBall( i, scaler )
	local ball = display.newImage( "images/ball_" .. ballColours[i] .. "_f.png" )
	ball:scale( scaler, scaler )
	ball.id = "ball" -- store object type as string attribute
	ball.colour = ballColours[i] -- store ball colour as string attribute
	ball.alpha = 0.8
	ball.actualRadius = radius * scaler
	return ball
end

local function newFreeBall()
	freeNo = #freeBalls + 1
	if (freeNo > 9) then
		freeNo = math.random( 8 )
	end
	local scale = math.random(3, 7) * 0.1
	local freeBall = newBall( freeNo, scale )
	freeBall.x = math.random(Cx * 0.4, Cx * 1.6)
	freeBall.y = -18
	local ballBody = { density=2.0, friction=10.0, bounce=0.1, radius=freeBall.actualRadius }
	physics.addBody( freeBall, ballBody )
	freeBall:applyLinearImpulse( math.random(-3,3), (55.0 * scale ), freeBall.x, freeBall.y )
	freeBalls[freeNo] = freeBall

	myscreenGroup:insert(freeBall)
end

local function removeBall(ball)
	if (ball~=nil) then
		ball:removeSelf()
    	ball = nil
    end 
end

local function isBallOffScreen(ball)
	local buffer = ball.actualRadius
	if ball.x ~= nil then
		print("ball.x .." .. tostring(ball.x))
			print("ball .." .. tostring(ball))
		if (ball.x < (0 - buffer)) then
			return true
		end
		if (ball.x > (W + buffer)) then
			return true
		end
		if (ball.y < (0 - buffer)) then
			return true
		end
		if (ball.y > (H + buffer)) then
			return true
		end
	end
end

local function cleanUpBalls()
	--if way off screen, remove image/physics
	-- check all obeject in centre group
	for i = 1, #freeBalls do
		if (isBallOffScreen(freeBalls[i])) then
			removeBall(freeBalls[i])
		end
	end
end

local function playGame()
	storyboard.gotoScene("gamepuzzle")
end

local function animate(event)
	local tDelta = event.time - tPrevious
	
	if (tDelta > 1500) then
		tPrevious = event.time
		if menuIsRunning then
			newFreeBall()
		end
		timer.performWithDelay(1, cleanUpBalls(), 1)
	end

	--retry:toFront()
	--btn_settings:toFront()
	--highScores:toFront()
end

-- add all the event listening
function scene:enterScene(event)
	menuIsRunning = true
	background:toBack()
	storyboard.purgeScene("game")
	--btn_play.alpha=1
	--btn_play:addEventListener("tap",playGame)


	--playText:addEventListener( "tap", playGame )
	--btn_play:addEventListener( "touch", playGame )
	Runtime:addEventListener( "enterFrame", animate )
end

function scene:exitScene(event)
	menuIsRunning = false
	--playText:removeEventListener( "tap", playGame )
	--btn_play:removeEventListener("tap",playGame)

	--btn_play:removeEventListener( "touch", playGame )
	Runtime:removeEventListener( "enterFrame", animate )
	--if state~="leave" then
	--	for i = 1, #freeBalls do
	--		removeBall(freeBalls[i])
	--	end
	--end
end

function scene:destroyScene(event)
end

scene:addEventListener("createScene", scene)
scene:addEventListener("enterScene", scene)
scene:addEventListener("exitScene", scene)
scene:addEventListener("destroyScene", scene)

return scene
