----------------------------------------------------------------------------------
--
-- scenetemplate.lua
--
----------------------------------------------------------------------------------

local storyboard = require( "storyboard" )
local scene = storyboard.newScene()

local statsbackground

local widget = require("widget")

local GGData = require("GGData")

local prefs = GGData:new("preferences")

local Json = require("Json")

local ads = require "ads"

require "extras"

local localGroup
local mycountry
local myplayername
local usertextBox

local localusername	
local localusercountry
local errorLabel
local botoombarY = 35
local mybackground

local options =
{
	effect = "fade",
	navigation[1].timeForFade,
}
----------------------------------------------------------------------------------
-- 
--	NOTE:
--	
--	Code outside of listener functions (below) will only be executed once,
--	unless storyboard.removeScene() is called.
-- 
---------------------------------------------------------------------------------
function loadPrefs()
	prefs:load()


	localusername = prefs.username 
	
	localusercountry = prefs.usercountry 
	
end

local function changeMusic(e)
        local x
        local y
        x = btnSound.x
        y = btnSound.y
        btnSound:removeEventListener("tap",changeMusic)
        mygroup:remove(btnSound)

        if (withBackgroundMousic==true) then
            withBackgroundMousic = false
            btnSound = display.newImageRect(interface[1].soundPlay, interface[1].soundButtonDimention, interface[1].soundButtonDimention )

            print("audio.stop()")
            audio.stop()
        else 
            withBackgroundMousic = true
            btnSound = display.newImageRect(interface[1].soundPause, interface[1].soundButtonDimention, interface[1].soundButtonDimention )
            
            playLoopSound( theme_sound,1, -1 , 0.3)

        end

        btnSound.x = x
        btnSound.y = y
        mygroup:insert(btnSound)
        btnSound:addEventListener("tap",changeMusic)
end

local function gotoMenu()
	--storyboard.gotoScene( "mymenu", options )
	storyboard.gotoScene( "game", options)
end

-- in a module where fullscreen ads are to be displayed
    local isSimulator = system.getInfo("environment") == "simulator"
    local function testNetworkConnection()
        local netConn = require('socket').connect('www.apple.com', 80)
        if netConn == nil then
            return false
        end
        netConn:close()
        return true
    end


local function gotoMainMenu(e) 
	
	storyboard.gotoScene( "game", options )
end





	
-- in a module where fullscreen ads are to be displayed
    local isSimulator = system.getInfo("environment") == "simulator"
    local function testNetworkConnection()
        local netConn = require('socket').connect('www.apple.com', 80)
        if netConn == nil then
            return false
        end
        netConn:close()
        return true
    end



function url_decode(str)
  str = string.gsub (str, "+", " ")
  str = string.gsub (str, "%%(%x%x)",
      function(h) return string.char(tonumber(h,16)) end)
  str = string.gsub (str, "\r\n", "\n")
  return str
end

function url_encode(str)
  if (str) then
    str = string.gsub (str, "\n", "\r\n")
    str = string.gsub (str, "([^%w ])",
        function (c) return string.format ("%%%02X", string.byte(c)) end)
    str = string.gsub (str, " ", "+")
  end
  return str	
end

table.count = function(t)  
  local c = 0  
  for _ in pairs(t) do  
    c = c + 1  
  end  
  return c  
end



	local initVars = function ()
		local networkListener = function( event )
		        if ( event.isError ) then
		                print( "Network error!")
						--print_r(event)
						errorLabel = display.newText( "Internet connection not found. Can not load scores", 250, 50, font, 32 )
						errorLabel.x = display.contentCenterX
						errorLabel.y = display.contentCenterY - 50
						errorLabel:setTextColor( 255, 255, 255 ) 
						localGroup:insert(errorLabel)
		        else
					print("event.response" .. tostring(event.response))
	                local data = Json.Decode(event.response)
					print("data" .. tostring(data))
					local function print_entry(e, pos_y, id)
						
						
						local lbl_pos = display.newText( id..".", 70, 80+tonumber(pos_y)*32, native.systemFontBold, 32 )
						localGroup:insert(lbl_pos)
						lbl_pos:setTextColor(255,255,255)
						print("e.playername" .. tostring(e.playername))
						local lbl_name = display.newText( string.sub(e.playername,1,10), 200, 80+tonumber(pos_y)*32, native.systemFontBold, 32 )
						localGroup:insert(lbl_name)
						print("e.score" .. tostring(e.score))
						local lbl_country = display.newText( string.sub(e.country,1,10), 450, 80+tonumber(pos_y)*32, native.systemFontBold, 32 )
						localGroup:insert(lbl_country)
						--local lbl_os = display.newText( e.os, 320, 60+tonumber(pos_y)*16, native.systemFontBold, 14 )
						--localGroup:insert(lbl_os)
						local lbl_score = display.newText( e.score, 650, 80+tonumber(pos_y)*32, native.systemFontBold, 32 )
						localGroup:insert(lbl_score)
						--local lbl_carrots = display.newText( e.carrots, 250, 110+tonumber(pos_y)*16, native.systemFontBold, 14 )
						--localGroup:insert(lbl_carrots)
						--lbl_name.x, lbl_carrots.x, lbl_score.x = 122, 245, 365
						if id==data.pos then
							lbl_name:setTextColor(0,200,0)
							lbl_score:setTextColor(0,200,0)
							--lbl_carrots:setTextColor(0,200,0)
						else
							lbl_name:setTextColor(255,255,255)
							lbl_score:setTextColor(255,255,255)
							--lbl_carrots:setTextColor(255,255,255)
						end
					end
					print("data.scores:" .. tostring(data.scores))
					local i = 1
					
					--epikefalides
						local lbl_pose = display.newText( "Rank", 70, 70, native.systemFontBold, 38 )
						localGroup:insert(lbl_pose)
						lbl_pose:setTextColor(255,255,255)
						local lbl_namee = display.newText( "Player", 200, 70, native.systemFontBold, 38 )
						localGroup:insert(lbl_namee)
						local lbl_countryy = display.newText( "Country", 450, 70, native.systemFontBold, 38 )
						localGroup:insert(lbl_countryy)
						--local lbl_os = display.newText( "OS", 320, 50, native.systemFontBold, 14 )
						--localGroup:insert(lbl_os)
						local lbl_scoree = display.newText( "Score", 650, 70, native.systemFontBold, 38 )
						localGroup:insert(lbl_scoree)
						lbl_namee:setTextColor(255,255,255)
						lbl_scoree:setTextColor(255,255,255)
							
					--end epikefalides
					
					for _,e in pairs(data.scores) do  --top pos onomazei to response
						--if e.id<=10 then
							
							--print("e" .. tostring(e))
							--print("e.id" .. tostring(e.id))
							--print_entry(e, e.id, e.id)
							print_entry(e, i, i)
							i = i + 1
						--end
					end

		        end
		end

		local params = {
			player_id = system.getInfo("deviceID"),--settings.game.player_id,
			player_name = username,--system.getInfo( "name" ),--settings.game.player_name,
			score = distance,
			carrots = carrots,
			info_name = system.getInfo("name"),
			info_mode = system.getInfo("mode"),
			info_deviceID = system.getInfo("deviceID"),
			info_environment = system.getInfo("environment"),
			info_simulator = system.getInfo("simulator"),
			info_device = system.getInfo("device"),
			info_platformName = system.getInfo("platformName"),
			info_platformVersion = system.getInfo("platformVersion"),
			info_version = system.getInfo("version"),
			info_build = system.getInfo("build"),
		}
		local p = {body=""}
		local i = 1
		for k,v in pairs(params) do
			p.body = p.body..k.."="..url_encode(v)
			if i~=table.count(params) then
				p.body = p.body.."&"
			end
			i = i+1
		end
		print("p: " .. tostring(p.body))
		--network.request( "http://run_rabbit_run.aabweber.com/stat.php", "POST", networkListener, p )
		
		--edo 8a ftiakso to request
		--kalo prota to load prefs gia na mazepso ta stoixeia tou paixti
		loadPrefs()
		local myreq
		score = myScoreToStore
		if (score==nil) then
			score = 1
		end

		myplayername = localusername--"tony - Greece"
		if (myplayername==nil) then
			myplayername = ""
		end
		if (myplayername=="") then
			myplayername = Mainusername
		end

		player_id = system.getInfo("deviceID")
		if (player_id == nil) then
			player_id = "playerid"
		end
		oss = stats[1].os

		mycountry = localusercountry
		if (mycountry==nil) then
			mycountry = ""
		end
		if (mycountry=="") then
			mycountry = Mainusercountry
		end


		myreq = "application=" .. stats[1].appname .. "&score=" .. tostring(score) .. "&playername=" .. tostring(myplayername) .. "&deviceid=" .. tostring(player_id) .. "&country=" .. tostring(mycountry) .. "&os=" .. tostring(oss)
		print("myreq: " ..tostring(myreq))
		network.request( "http://corona.itholster.com/SmurferRun.aspx?" .. myreq, "GET", networkListener)

	end	

	
	
---------------------------------------------------------------------------------
-- BEGINNING OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- Called when the scene's view does not exist:
function scene:createScene( event )
	local group = self.view

	storyboard.removeScene("game")
	storyboard.purgeAll()
	-----------------------------------------------------------------------------
		
	--	CREATE display objects and add them to 'group' here.
	--	Example use-case: Restore 'group' from previously saved state.
	
	-----------------------------------------------------------------------------
	mybackground =  display.newImage(interface[1].splashBackground)--, 380, 570 )
    mybackground.x = display.contentCenterX
    mybackground.y = display.contentCenterY
    mybackground.alpha = 0.2
    group:insert( mybackground )

    --splash_image =  display.newImageRect(interface[1].splashImage, 250, 250 )
    --splash_image.x = display.contentCenterX
    --splash_image.y = display.contentCenterY
    --splash_image.alpha = 0.3
    --group:insert( splash_image )

    
end


-- Called immediately after scene has moved onscreen:
function scene:enterScene( event )
	local group = self.view
	
	localGroup = group 
	-----------------------------------------------------------------------------
		
	--	INSERT code here (e.g. start timers, load audio, start listeners, etc.)
	
	-----------------------------------------------------------------------------
	
	
	initVars()
	
	
	local myYDimention = display.contentCenterY + interface[1].downButtonsDimention
	local retry = display.newImageRect(interface[1].backbutton, interface[1].soundButtonDimention, interface[1].soundButtonDimention )
    retry.x = interface[1].btnMenuX
    retry.y = topbarButtons
	group:insert( retry )
	--retry.xScale,retry.yScale=2,2
	retry.alpha=1
	retry:addEventListener("tap",gotoMenu)
	
	if (withBackgroundMousic==true) then
        btnSound = display.newImageRect("images/buttons/btn_sound-sheet0.png", interface[1].soundButtonDimention, interface[1].soundButtonDimention )
        audio.stop()
        playLoopSound( theme_sound,1, -1 , 0.3)
    else 
        btnSound = display.newImageRect("images/buttons/btn_sound-sheet1.png", interface[1].soundButtonDimention, interface[1].soundButtonDimention )
        audio.stop()
    end
    btnSound.x = display.contentWidth - interface[1].soundButtonDimention--100--centerX
    btnSound.y = topbarButtons-- 20 -- display.contentHeight - 50
    group:insert(btnSound)
    --group:insert(btnSound)
    --btnSound:addEventListener("tap",changeMusic)
    btnSound:toFront()
    btnSound:addEventListener("tap",changeMusic)




    ---- ADS

	
	local showAds = math.random( 0, 2 )
	if showAds == 0 then
		
		if ( isSimulator or not testNetworkConnection() ) then
			print("on simulator or no network connection, and therefore, no fullscreen ads")
		else
				local function adListener( event )
					if event.isError then
						-- Failed to receive an ad.
					end
				end
				ads.init( "admob", stats[1].admobid, adListener )
				ads.show( "interstitial", { x=0, y=0 } )
		end
	end
	
	---- END ADS

end


-- Called when scene is about to move offscreen:
function scene:exitScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. stop timers, remove listeners, unload sounds, etc.)
	
	-----------------------------------------------------------------------------
	
end


-- Called prior to the removal of scene's "view" (display group)
function scene:destroyScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. remove listeners, widgets, save state, etc.)
	
	-----------------------------------------------------------------------------
	
end


---------------------------------------------------------------------------------
-- END OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- "createScene" event is dispatched if scene's view does not exist
scene:addEventListener( "createScene", scene )

-- "enterScene" event is dispatched whenever scene transition has finished
scene:addEventListener( "enterScene", scene )

-- "exitScene" event is dispatched before next scene's transition begins
scene:addEventListener( "exitScene", scene )

-- "destroyScene" event is dispatched before view is unloaded, which can be
-- automatically unloaded in low memory situations, or explicitly via a call to
-- storyboard.purgeScene() or storyboard.removeScene().
scene:addEventListener( "destroyScene", scene )

---------------------------------------------------------------------------------

return scene