-----------------------------------------------------------------------------------------
--
-- menu.lua
--
-----------------------------------------------------------------------------------------

-- allow this lua file to be used with storyboards
local storyboard = require "storyboard"
local scene = storyboard.newScene()
local utility = require ("utility")
local math = require ("math")

local physics = require("physics")
local myscreenGroup
local menuIsRunning = true

require "extras"

physics.start()
physics.setGravity( 0, 0 )

local retry
local btn_settings
local highScores

local background

local state = "run"
--local playText

local W = display.contentWidth
local H = display.contentHeight
local Cx = W * 0.5
local Cy = H * 0.5
local radius = 64 -- constant on image
local ballColours = { "black", "blue", "red", "green", "gold", "blue", "gold", "red", "green" }
local freeBalls = {}
local tPrevious

local options =
{
	effect = "fade",
	navigation[1].timeForFade,
}

local function changeMusic(e)
        local x
        local y
        x = btnSound.x
        y = btnSound.y
        btnSound:removeEventListener("tap",changeMusic)
        myscreenGroup:remove(btnSound)

        if (withBackgroundMousic==true) then
            withBackgroundMousic = false
            btnSound = display.newImageRect(interface[1].soundPlay, interface[1].soundButtonDimention, interface[1].soundButtonDimention)

            print("audio.stop()")
            audio.stop()
        else 
            withBackgroundMousic = true
            btnSound = display.newImageRect(interface[1].soundPause, interface[1].soundButtonDimention, interface[1].soundButtonDimention)
            
            playLoopSound( theme_sound,1, -1 , 0.3)

        end

        btnSound.x = x
        btnSound.y = y
        myscreenGroup:insert(btnSound)
        btnSound:addEventListener("tap",changeMusic)
end

local function gotomenu(e)
    storyboard.gotoScene( "menu", {effect="fade"} )
end

local function gotoPlay()
	--storyboard.gotoScene( "level1Storyboard", options)
	state = "leave"
	background.alpha = 0
	storyboard.gotoScene("game",options)

	--storyboard.gotoScene( "gohome2", {effect="fade"} )
end

local function gotoHighScores()
	storyboard.gotoScene( "stat", options )
end

local function gotoSettings()
	storyboard.gotoScene( "userDetails", options )
end

-- what to do when the screen loads
function scene:createScene(event)

	storyboard.purgeScene("game")
	storyboard.purgeAll()

	myscreenGroup = self.view
	background = display.newImageRect(interface[1].gameBg, 1080, 1920)
	background.alpha = 1--0.9
	utility.putInCentre(background)  

	--local title = display.newText("SillyBalls!", 0, 0, "Helvetica", 104) 
	--utility.centreObjectX(title)
	--title.anchorY = 0
	--title:translate(0, 120)
	--title:setFillColor( 0, 0, 0 )
	
	--playText = display.newText("PLAY GAME", 0, 0, "Helvetica", 98) 
	--utility.centreObjectX(playText)
	--playText.anchorY = 0
	--playText:translate(0, 480)
	--utility.setColour(playText, 175, 0, 175)
	local myYDimention = display.contentCenterY + interface[1].downButtonsDimention
	retry = display.newImageRect(interface[1].gamePlay, 180, 180 )
	retry.x = display.contentCenterX - 200
	retry.y = myYDimention
	myscreenGroup:insert( retry )
	--retry.xScale,retry.yScale=2,2
	retry.alpha=1
	retry:addEventListener("tap",gotoPlay)

	highScores = display.newImageRect(interface[1].highScores, 180, 180 )
	highScores.x = display.contentCenterX
	highScores.y = myYDimention
	myscreenGroup:insert( highScores )
	--retry.xScale,retry.yScale=2,2
	highScores.alpha=1
	highScores:addEventListener("tap",gotoHighScores)

	btn_settings = display.newImageRect(interface[1].settings, 180, 180 )
	btn_settings.x = display.contentCenterX + 200
	btn_settings.y = myYDimention
	myscreenGroup:insert( btn_settings )
	--retry.xScale,retry.yScale=2,2
	btn_settings.alpha=1
	btn_settings:addEventListener("tap",gotoSettings)

	if (withBackgroundMousic==true) then
        btnSound = display.newImageRect("images/buttons/btn_sound-sheet0.png", interface[1].soundButtonDimention, interface[1].soundButtonDimention )
        audio.stop()
        playLoopSound( theme_sound,1, -1 , 0.3)
    else 
        btnSound = display.newImageRect("images/buttons/btn_sound-sheet1.png", interface[1].soundButtonDimention, interface[1].soundButtonDimention )
        audio.stop()
    end
     btnSound.x = display.contentWidth - interface[1].soundButtonDimention--100--centerX
    btnSound.y = topbarButtons-- 20 -- display.contentHeight - 50
    myscreenGroup:insert(btnSound)
    --group:insert(btnSound)
    --btnSound:addEventListener("tap",changeMusic)
    btnSound:toFront()
    btnSound:addEventListener("tap",changeMusic)


	local retry = display.newImageRect(interface[1].backbutton, interface[1].soundButtonDimention, interface[1].soundButtonDimention )
    retry.x = interface[1].btnMenuX
    retry.y = topbarButtons
    myscreenGroup:insert( retry )
    --retry.xScale,retry.yScale=2,2
    retry.alpha=1
    retry:addEventListener("tap",gotomenu)

    local imagesign =  display.newImageRect( interface[1].howtoplay, 700, 756 )
	imagesign.x = display.contentCenterX
	imagesign.y = display.contentCenterY - 65
	imagesign:toFront()
	myscreenGroup:insert( imagesign )
	--[[
	local lbl_Info = display.newText( "Instructions: ", 250, 50, font, 36 )
	lbl_Info.x = display.contentCenterX
	lbl_Info.y = display.contentCenterY - 110
	lbl_Info:setTextColor( 0, 0, 0 ) 
	myscreenGroup:insert(lbl_Info)

	local lbl_Info2 = display.newText( "Tap to rotate the silly balls", 250, 50, font, 36 )
	lbl_Info2.x = display.contentCenterX
	lbl_Info2.y = display.contentCenterY - 100
	lbl_Info2:setTextColor( 0, 0, 0 ) 
	myscreenGroup:insert(lbl_Info2)

	local lbl_Info3 = display.newText( "Match at least 3 balls of each colour", 250, 50, font, 30 )
	lbl_Info3.x = display.contentCenterX
	lbl_Info3.y = display.contentCenterY  - 70
	lbl_Info3:setTextColor( 0, 0, 0 ) 
	myscreenGroup:insert(lbl_Info3)

	local lbl_Info5 = display.newText( "Black balls can't be removed!", 250, 50, font, 30 )
	lbl_Info5.x = display.contentCenterX
	lbl_Info5.y = display.contentCenterY - 40
	lbl_Info5:setTextColor( 0, 0, 0 ) 
	myscreenGroup:insert(lbl_Info5)

	local lbl_Info4 = display.newText( "Match correct and get points and time!", 250, 50, font, 30 )
	lbl_Info4.x = display.contentCenterX
	lbl_Info4.y = display.contentCenterY - 10
	lbl_Info4:setTextColor( 0, 0, 0 ) 
	myscreenGroup:insert(lbl_Info4)

]]
	--local myYDimention = display.contentCenterY + 400
	--btn_play = display.newImageRect(interface[1].play, 270, 88 )
	--btn_play.x = display.contentCenterX
	--btn_play.y = myYDimention
	--retry.xScale,retry.yScale=2,2
	--btn_play.alpha=0
	--screenGroup:insert( btn_play )
	--retry.xScale,retry.yScale=2,2
	


	tPrevious = system.getTimer() 
end

local function newBall( i, scaler )
	local ball = display.newImage( "images/ball_" .. ballColours[i] .. "_f.png" )
	ball:scale( scaler, scaler )
	ball.id = "ball" -- store object type as string attribute
	ball.colour = ballColours[i] -- store ball colour as string attribute
	ball.alpha = 0.8
	ball.actualRadius = radius * scaler
	return ball
end

local function newFreeBall()
	freeNo = #freeBalls + 1
	if (freeNo > 9) then
		freeNo = math.random( 8 )
	end
	local scale = math.random(3, 7) * 0.1
	local freeBall = newBall( freeNo, scale )
	freeBall.x = math.random(Cx * 0.4, Cx * 1.6)
	freeBall.y = -18
	local ballBody = { density=2.0, friction=10.0, bounce=0.1, radius=freeBall.actualRadius }
	physics.addBody( freeBall, ballBody )
	freeBall:applyLinearImpulse( math.random(-3,3), (55.0 * scale ), freeBall.x, freeBall.y )
	freeBalls[freeNo] = freeBall

	myscreenGroup:insert(freeBall)
end

local function removeBall(ball)
	if (ball~=nil) then
		ball:removeSelf()
    	ball = nil
    end 
end

local function isBallOffScreen(ball)
	local buffer = ball.actualRadius
	if ball.x ~= nil then
		print("ball.x .." .. tostring(ball.x))
			print("ball .." .. tostring(ball))
		if (ball.x < (0 - buffer)) then
			return true
		end
		if (ball.x > (W + buffer)) then
			return true
		end
		if (ball.y < (0 - buffer)) then
			return true
		end
		if (ball.y > (H + buffer)) then
			return true
		end
	end
end

local function cleanUpBalls()
	--if way off screen, remove image/physics
	-- check all obeject in centre group
	for i = 1, #freeBalls do
		if (isBallOffScreen(freeBalls[i])) then
			removeBall(freeBalls[i])
		end
	end
end

local function playGame()
	storyboard.gotoScene("gamepuzzle")
end

local function animate(event)
	local tDelta = event.time - tPrevious
	
	if (tDelta > 1500) then
		tPrevious = event.time
		if menuIsRunning then
			newFreeBall()
		end
		timer.performWithDelay(1, cleanUpBalls(), 1)
	end

	--retry:toFront()
	--btn_settings:toFront()
	--highScores:toFront()
end

-- add all the event listening
function scene:enterScene(event)
	menuIsRunning = true
	background:toBack()
	storyboard.purgeScene("game")
	--btn_play.alpha=1
	--btn_play:addEventListener("tap",playGame)


	--playText:addEventListener( "tap", playGame )
	--btn_play:addEventListener( "touch", playGame )
	Runtime:addEventListener( "enterFrame", animate )
end

function scene:exitScene(event)
	menuIsRunning = false
	--playText:removeEventListener( "tap", playGame )
	--btn_play:removeEventListener("tap",playGame)

	--btn_play:removeEventListener( "touch", playGame )
	Runtime:removeEventListener( "enterFrame", animate )
	--if state~="leave" then
	--	for i = 1, #freeBalls do
	--		removeBall(freeBalls[i])
	--	end
	--end
end

function scene:destroyScene(event)
end

scene:addEventListener("createScene", scene)
scene:addEventListener("enterScene", scene)
scene:addEventListener("exitScene", scene)
scene:addEventListener("destroyScene", scene)

return scene
