----------------------------------------------------------------------------------
--
-- scenetemplate.lua
--
----------------------------------------------------------------------------------

local storyboard = require( "storyboard" )
local scene = storyboard.newScene()

local widget = require("widget")

local myscreenGroup

local btnSound


--typeOfPlay
----------------------------------------------------------------------------------
-- 
--	NOTE:
--	
--	Code outside of listener functions (below) will only be executed once,
--	unless storyboard.removeScene() is called.
-- 
---------------------------------------------------------------------------------

--local sndNoMatch = audio.loadSound("audio/nomatch.mp3")
--local sndMatch = audio.loadSound("audio/match.mp3")
--local sndWinner = audio.loadSound("audio/winner.mp3")


local function gotoPlay(e)
    currentLevel = e.target.idx
    storyboard.purgeScene("gamepuzzle")
    storyboard.removeScene("gamepuzzle")
    storyboard.gotoScene( "gamepuzzle", {effect="fade"} )

end

local function changeMusic(e)
         local x
        local y
        x = btnSound.x
        y = btnSound.y
        btnSound:removeEventListener("tap",changeMusic)
        myscreenGroup:remove(btnSound)

        if (withBackgroundMousic==true) then
            withBackgroundMousic = false
            btnSound = display.newImageRect(interface[1].soundPlay, interface[1].soundButtonDimention, interface[1].soundButtonDimention)

            print("audio.stop()")
            audio.stop()
        else 
            withBackgroundMousic = true
            btnSound = display.newImageRect(interface[1].soundPause, interface[1].soundButtonDimention, interface[1].soundButtonDimention)
            
            playLoopSound( theme_sound,1, -1 , 0.3)

        end

        btnSound.x = x
        btnSound.y = y
        myscreenGroup:insert(btnSound)
        btnSound:addEventListener("tap",changeMusic)
end


local function gotomenu(e)
    storyboard.gotoScene( "menu", {effect="fade"} )
end



local function gotoStage1(e)
	--storyboard.hideOverlay("fromTop")
	currentStage = 1
	storyboard.gotoScene( "selectlevel", {effect="fade"} )
end


local function gotoStage2(e)
    --storyboard.hideOverlay("fromTop")
    currentStage = 2
    storyboard.gotoScene( "selectlevel", {effect="fade"} )
end

local function gotoStage3(e)
    --storyboard.hideOverlay("fromTop")
    currentStage = 3
    storyboard.gotoScene( "selectlevel", {effect="fade"} )
end
---------------------------------------------------------------------------------
-- BEGINNING OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- Called when the scene's view does not exist:
function scene:createScene( event )
	local group = self.view
	myscreenGroup = group

	local prior_scene = storyboard.getPrevious()
	storyboard.purgeScene( prior_scene )
	
	storyboard.purgeScene("play")
	storyboard.purgeAll()

	
	if (withBackgroundMousic==true) then
        btnSound = display.newImageRect("images/buttons/btn_sound-sheet0.png", interface[1].soundButtonDimention, interface[1].soundButtonDimention )
        audio.stop()
        playLoopSound( theme_sound,1, -1 , 0.3)
    else 
        btnSound = display.newImageRect("images/buttons/btn_sound-sheet1.png", interface[1].soundButtonDimention, interface[1].soundButtonDimention )
        audio.stop()
    end
    btnSound.x = display.contentWidth - interface[1].soundButtonDimention--100--centerX
    btnSound.y = topbarButtons-- 20 -- display.contentHeight - 50
    myscreenGroup:insert(btnSound)
    --group:insert(btnSound)
    --btnSound:addEventListener("tap",changeMusic)
    btnSound:toFront()
    btnSound:addEventListener("tap",changeMusic)

    local myYDimention = display.contentCenterY + interface[1].downButtonsDimention
    local retry = display.newImageRect(interface[1].backbutton, interface[1].soundButtonDimention, interface[1].soundButtonDimention )
    retry.x = interface[1].btnMenuX
    retry.y = topbarButtons
    myscreenGroup:insert( retry )
    --retry.xScale,retry.yScale=2,2
    retry.alpha=1
    retry:addEventListener("tap",gotomenu)


	-----------------------------------------------------------------------------
		
	--	CREATE display objects and add them to 'group' here.
	--	Example use-case: Restore 'group' from previously saved state.
	
	-----------------------------------------------------------------------------

	--local bLabel = "English Alphabet"
	--local tapBtn = widget.newButton{label = bLabel, style = bStyle, onRelease=goAlphabet}
	
	
		  --SETUP LEVEL BUTTONS DYNAMICALLY
    loadPrefs()
    local startingY = menuScreen.levelsIconsYDimention + 60--150
    local yTimes = 0
    local lastLevelY = 0
    --or idx=1, stagesTotalNumber-1, 1 do

        print("stagesTotalNumber: " .. tostring(stagesTotalNumber))
        
        --for myIndex=idx, idx + 1 do
        for idx=(currentStage-1)*14 + 1, (currentStage-1)*20 + 1 + 14 - 2, 2 do
            print("idx " .. tostring(idx))
            print("(currentStage-1)*20 + 1 + 15 - 2 " .. tostring((currentStage-1)*20 + 1 + 15 - 2))
            local yDimention = (yTimes * 155) 
            local xTimes = 0
            --print("myIndex " .. myIndex)
            --print("levelsimages[myIndex].level " .. levelsimages[myIndex].level)
            local backgroundoflevel
            --local level
            local mask
            for myIndex=idx, idx + 1 do
                if(((myIndex < 43) and (currentStage == 3)) or ((myIndex < 29) and (currentStage == 2)) or ((myIndex < 15) and (currentStage == 1))) then --elegxos min peraso to 33 level kai fao itta
                    backgroundoflevel = display.newImageRect(interface[1].button, 300, 135)
                    backgroundoflevel.x = display.contentCenterX - 160  + xTimes*320

                    --level.y = 360
                    if yTimes == 0 then
                        --startingY
                        backgroundoflevel.y = startingY -- yDimention --+ 30--centerY - 110
                    else
                        backgroundoflevel.y = startingY + yDimention
                    end
                    myscreenGroup:insert(backgroundoflevel)

                    -- level = display.newImageRect(stagesImages[1].image, 40, 40)
                     --level.x = backgroundoflevel.x
                     --level.y = backgroundoflevel.y
                     
                    --sceneGroup:insert(level)

                    print("levelLocked[myIndex] " .. tostring(myIndex) .. " -- " .. tostring(levelLocked[myIndex]))
                    if levelLocked[myIndex] == nil then levelLocked[myIndex] = true end

                    if not levelLocked[myIndex] then
                        
                        --display.newImage(levelsimages[myIndex].level)
                         --mask = graphics.newMask("assets/gfx/100/play2.png")
                        local lvleTxt = display.newText(tostring(myIndex) , 0 , 0 , native.systemFont, 65)
                       lvleTxt:setTextColor (255, 255, 255)
                       print("lvleTxt" .. tostring(lvleTxt))
                        lvleTxt.x = backgroundoflevel.x-- - 10
                        lvleTxt.y = backgroundoflevel.y
                        --level:insert(lvleTxt)
                        myscreenGroup:insert(lvleTxt)

                       
                       


                    else
                        --level = display.newImage("assets/gfx/levelbutton3.png")
                        --level.alpha = 0.5

                        local lock = display.newImageRect(menuScreen.lock, 80,80)
                        lock.x = backgroundoflevel.x
                        lock.y = backgroundoflevel.y
                        lock.alpha = 1
                        myscreenGroup:insert(lock)
                        --mask = graphics.newMask("assets/gfx/100/mask2.png")
                    end
                    --level:setMask(mask) 

                   
                     

                    if not levelLocked[myIndex] then
                                print("testindex" .. tostring(myIndex))
                                backgroundoflevel.idx = myIndex
                                backgroundoflevel:addEventListener( "tap", gotoPlay )
                                --level:addEventListener("tap", function(e) 
                                --    composer.gotoScene( "src.levelSceneMine", {params ={currentClickedStage=myIndex}} )
                                --end)
                    else

                    end

                    xTimes = xTimes + 1
                end --if
           end --for myIndex=idx, idx + 2 do
        --end --end for
        yTimes = yTimes + 1
        lastLevelY = backgroundoflevel.y 
    end
end


-- Called immediately after scene has moved onscreen:
function scene:enterScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
		
	--	INSERT code here (e.g. start timers, load audio, start listeners, etc.)
	
	-----------------------------------------------------------------------------
	
	--print("Enterd");
end


-- Called when scene is about to move offscreen:
function scene:exitScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. stop timers, remove listeners, unload sounds, etc.)
	
	-----------------------------------------------------------------------------
	
end


-- Called prior to the removal of scene's "view" (display group)
function scene:destroyScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. remove listeners, widgets, save state, etc.)
	
	-----------------------------------------------------------------------------
	
end


---------------------------------------------------------------------------------
-- END OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- "createScene" event is dispatched if scene's view does not exist
scene:addEventListener( "createScene", scene )

-- "enterScene" event is dispatched whenever scene transition has finished
scene:addEventListener( "enterScene", scene )

-- "exitScene" event is dispatched before next scene's transition begins
scene:addEventListener( "exitScene", scene )

-- "destroyScene" event is dispatched before view is unloaded, which can be
-- automatically unloaded in low memory situations, or explicitly via a call to
-- storyboard.purgeScene() or storyboard.removeScene().
scene:addEventListener( "destroyScene", scene )

---------------------------------------------------------------------------------

return scene