----------------------------------------------------------------------------------
--
-- scenetemplate.lua
--
----------------------------------------------------------------------------------

local storyboard = require( "storyboard" )
local scene = storyboard.newScene()

local widget = require("widget")

local myscreenGroup

local btnSound


--typeOfPlay
----------------------------------------------------------------------------------
-- 
--	NOTE:
--	
--	Code outside of listener functions (below) will only be executed once,
--	unless storyboard.removeScene() is called.
-- 
---------------------------------------------------------------------------------

--local sndNoMatch = audio.loadSound("audio/nomatch.mp3")
--local sndMatch = audio.loadSound("audio/match.mp3")
--local sndWinner = audio.loadSound("audio/winner.mp3")




local function changeMusic(e)
         local x
        local y
        x = btnSound.x
        y = btnSound.y
        btnSound:removeEventListener("tap",changeMusic)
        myscreenGroup:remove(btnSound)

        if (withBackgroundMousic==true) then
            withBackgroundMousic = false
            btnSound = display.newImageRect(interface[1].soundPlay, interface[1].soundButtonDimention, interface[1].soundButtonDimention)

            print("audio.stop()")
            audio.stop()
        else 
            withBackgroundMousic = true
            btnSound = display.newImageRect(interface[1].soundPause, interface[1].soundButtonDimention, interface[1].soundButtonDimention)
            
            playLoopSound( theme_sound,1, -1 , 0.3)

        end

        btnSound.x = x
        btnSound.y = y
        myscreenGroup:insert(btnSound)
        btnSound:addEventListener("tap",changeMusic)
end


local function gotomenu(e)
    storyboard.gotoScene( "menu", {effect="fade"} )
end



local function gotoStage1(e)
	--storyboard.hideOverlay("fromTop")
	currentStage = 1
	storyboard.gotoScene( "selectlevel", {effect="fade"} )
end


local function gotoStage2(e)
    --storyboard.hideOverlay("fromTop")
    currentStage = 2
    storyboard.gotoScene( "selectlevel", {effect="fade"} )
end

local function gotoStage3(e)
    --storyboard.hideOverlay("fromTop")
    currentStage = 3
    storyboard.gotoScene( "selectlevel", {effect="fade"} )
end
---------------------------------------------------------------------------------
-- BEGINNING OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- Called when the scene's view does not exist:
function scene:createScene( event )
	local group = self.view
	myscreenGroup = group

	local prior_scene = storyboard.getPrevious()
	storyboard.purgeScene( prior_scene )
	
	storyboard.purgeScene("play")
	storyboard.purgeAll()

	
	if (withBackgroundMousic==true) then
        btnSound = display.newImageRect("images/buttons/btn_sound-sheet0.png", interface[1].soundButtonDimention, interface[1].soundButtonDimention )
        audio.stop()
        playLoopSound( theme_sound,1, -1 , 0.3)
    else 
        btnSound = display.newImageRect("images/buttons/btn_sound-sheet1.png", interface[1].soundButtonDimention, interface[1].soundButtonDimention )
        audio.stop()
    end
    btnSound.x = display.contentWidth - interface[1].soundButtonDimention--100--centerX
    btnSound.y = topbarButtons-- 20 -- display.contentHeight - 50
    myscreenGroup:insert(btnSound)
    --group:insert(btnSound)
    --btnSound:addEventListener("tap",changeMusic)
    btnSound:toFront()
    btnSound:addEventListener("tap",changeMusic)


	-----------------------------------------------------------------------------
		
	--	CREATE display objects and add them to 'group' here.
	--	Example use-case: Restore 'group' from previously saved state.
	
	-----------------------------------------------------------------------------

	--local bLabel = "English Alphabet"
	--local tapBtn = widget.newButton{label = bLabel, style = bStyle, onRelease=goAlphabet}
	
	
		    --SETUP LEVEL BUTTONS DYNAMICALLY
    loadPrefs()

    --level1
    local backgroundoflevel1 = display.newImageRect(interface[1].stage1, 325, 351)
    backgroundoflevel1.x = display.contentCenterX
    backgroundoflevel1.y = display.contentCenterY - backgroundoflevel1.height - 50

    myscreenGroup:insert(backgroundoflevel1)
    if not stagesLocked[1] then
        backgroundoflevel1:addEventListener( "tap", gotoStage1 )
        local playbtn = display.newImageRect(interface[1].play, 180, 81)
        playbtn.x = backgroundoflevel1.x - 5
        playbtn.y = backgroundoflevel1.y + 55
        myscreenGroup:insert(playbtn)
    else
        --level = display.newImage("assets/gfx/levelbutton3.png")
        level.alpha = 0.5

        local lock = display.newImageRect(menuScreen.lock, 60,60)
        lock.x = backgroundoflevel1.x 
        lock.y = backgroundoflevel1.y
        lock.alpha = 1
        myscreenGroup:insert(lock)
    end

    --END LEVEL1

     --level2
    local backgroundoflevel2 = display.newImageRect(interface[1].stage2, 325, 351)
    backgroundoflevel2.x = display.contentCenterX
    backgroundoflevel2.y = display.contentCenterY

    myscreenGroup:insert(backgroundoflevel2)
    if not stagesLocked[2] then
        backgroundoflevel2:addEventListener( "tap", gotoStage2 )
        
        local playbtn = display.newImageRect(interface[1].play, 180, 81)
        playbtn.x = backgroundoflevel2.x - 5
        playbtn.y = backgroundoflevel2.y + 55
        myscreenGroup:insert(playbtn)
    else
        backgroundoflevel2.alpha = 0.5

        local lock = display.newImageRect(menuScreen.lock, 160,160)
        lock.x = backgroundoflevel2.x 
        lock.y = backgroundoflevel2.y + 30
        lock.alpha = 1
        myscreenGroup:insert(lock)
    end
    --END LEVEL2


     --level3
    local backgroundoflevel3 = display.newImageRect(interface[1].stage3, 325, 351)
    backgroundoflevel3.x = display.contentCenterX
    backgroundoflevel3.y = display.contentCenterY + backgroundoflevel1.height + 50

    myscreenGroup:insert(backgroundoflevel3)
    if not stagesLocked[3] then
        backgroundoflevel3:addEventListener( "tap", gotoStage3 )
        local playbtn = display.newImageRect(interface[1].play, 180, 81)
        playbtn.x = backgroundoflevel3.x - 5
        playbtn.y = backgroundoflevel3.y + 55
        myscreenGroup:insert(playbtn)
    else
        backgroundoflevel3.alpha = 0.5

        local lock = display.newImageRect(menuScreen.lock, 160,160)
        lock.x = backgroundoflevel3.x 
        lock.y = backgroundoflevel3.y + 30
        lock.alpha = 1
        myscreenGroup:insert(lock)
    end
    --END LEVEL2

    local myYDimention = display.contentCenterY + interface[1].downButtonsDimention
    local retry = display.newImageRect(interface[1].backbutton, interface[1].soundButtonDimention, interface[1].soundButtonDimention )
    retry.x = interface[1].btnMenuX
    retry.y = topbarButtons
    myscreenGroup:insert( retry )
    --retry.xScale,retry.yScale=2,2
    retry.alpha=1
    retry:addEventListener("tap",gotomenu)

end


-- Called immediately after scene has moved onscreen:
function scene:enterScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
		
	--	INSERT code here (e.g. start timers, load audio, start listeners, etc.)
	
	-----------------------------------------------------------------------------
	
	--print("Enterd");
end


-- Called when scene is about to move offscreen:
function scene:exitScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. stop timers, remove listeners, unload sounds, etc.)
	
	-----------------------------------------------------------------------------
	
end


-- Called prior to the removal of scene's "view" (display group)
function scene:destroyScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. remove listeners, widgets, save state, etc.)
	
	-----------------------------------------------------------------------------
	
end


---------------------------------------------------------------------------------
-- END OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- "createScene" event is dispatched if scene's view does not exist
scene:addEventListener( "createScene", scene )

-- "enterScene" event is dispatched whenever scene transition has finished
scene:addEventListener( "enterScene", scene )

-- "exitScene" event is dispatched before next scene's transition begins
scene:addEventListener( "exitScene", scene )

-- "destroyScene" event is dispatched before view is unloaded, which can be
-- automatically unloaded in low memory situations, or explicitly via a call to
-- storyboard.purgeScene() or storyboard.removeScene().
scene:addEventListener( "destroyScene", scene )

---------------------------------------------------------------------------------

return scene