----------------------------------------------------------------------------------
--
-- scenetemplate.lua
--
----------------------------------------------------------------------------------

local storyboard = require( "storyboard" )
local scene = storyboard.newScene()
local GGData = require("GGData")
require "extras"

local prefs = GGData:new("preferences")

local background
local mygroup
local localusername
local localusercountry

----------------------------------------------------------------------------------
-- 
--	NOTE:
--	
--	Code outside of listener functions (below) will only be executed once,
--	unless storyboard.removeScene() is called.
-- 
---------------------------------------------------------------------------------

---------------------------------------------------------------------------------
-- BEGINNING OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------
local options =
{
	effect = "fade",
	navigation[1].timeForFade,
}

local function changeMusic(e)
        local x
        local y
        x = btnSound.x
        y = btnSound.y
        btnSound:removeEventListener("tap",changeMusic)
        mygroup:remove(btnSound)

        if (withBackgroundMousic==true) then
            withBackgroundMousic = false
            btnSound = display.newImageRect(interface[1].soundPlay, interface[1].soundButtonDimention, interface[1].soundButtonDimention )

            print("audio.stop()")
            audio.stop()
        else 
            withBackgroundMousic = true
            btnSound = display.newImageRect(interface[1].soundPause, interface[1].soundButtonDimention, interface[1].soundButtonDimention )
            
            playLoopSound( theme_sound,1, -1 , 0.3)

        end

        btnSound.x = x
        btnSound.y = y
        mygroup:insert(btnSound)
        btnSound:addEventListener("tap",changeMusic)
end

function loadPrefs()
	prefs:load()

	
	localusername = prefs.username 
	if username == nil then
		username = ""
	end	
	localusercountry = prefs.usercountry 
	if usercountry == nil then
		usercountry = ""
	end	
	
end

local function savePrefss()
	print("into PREFS")

	if (localusername=="") then
		prefs.username = prefs.username 
	else
		prefs.username = localusername
	end
	if (localusercountry=="") then
		prefs.usercountry = prefs.usercountry
	else
		prefs.usercountry = localusercountry
	end
	
	Mainusername = prefs.username
	Mainusercountry = prefs.usercountry
	prefs:save()
end 

local function saveAndgotoMenu(e) 

	savePrefss()
	storyboard.gotoScene( "menu", options )
end

local function gotomenu(e) 
		savePrefss()
	storyboard.gotoScene( "menu", options )
end


local function backgroundTap(e)
	native.setKeyboardFocus(nil)
end

local function userInputp(e)
	if(e.phase == "began") then
		localusername = e.target.text
		
	elseif(e.phase == "editing") then
		localusername = e.target.text
		
	elseif(e.phase == "ended") then
		localusername = e.target.text
		
	elseif(e.phase == "submitted") then
		localusername = e.target.text
		
	end
end

local function userInputpp(e)
	if(e.phase == "began") then
		localusercountry = e.target.text
		
	elseif(e.phase == "editing") then
		localusercountry = e.target.text
		
	elseif(e.phase == "ended") then
		localusercountry = e.target.text
		
	elseif(e.phase == "submitted") then
		localusercountry = e.target.text
		
	end
end

-- Called when the scene's view does not exist:
function scene:createScene( event )
	local group = self.view

	storyboard.removeScene("game")
	storyboard.purgeAll()

	background = display.newImageRect( interface[1].splashBackground, 1080, 1920)
	
	background.x = display.contentCenterX
	background.y = display.contentCenterY
	background:toBack()
	background.alpha = 0
	group:insert(background)

	-----------------------------------------------------------------------------
		
	--	CREATE display objects and add them to 'group' here.
	--	Example use-case: Restore 'group' from previously saved state.
	
	-----------------------------------------------------------------------------
	
end


-- Called immediately after scene has moved onscreen:
function scene:enterScene( event )
	local group = self.view
	
	mygroup = group

	-----------------------------------------------------------------------------
		
	--	INSERT code here (e.g. start timers, load audio, start listeners, etc.)
	
	-----------------------------------------------------------------------------
	local font = system.nativeFont

	background =  display.newImage(interface[1].splashBackground)--, 380, 570 )
    background.x = display.contentCenterX
    background.y = display.contentCenterY
    background.alpha = 0.2
    group:insert( background )

    --splash_image =  display.newImageRect(interface[1].splashImage, 250, 250 )
    --splash_image.x = display.contentCenterX
    --splash_image.y = display.contentCenterY
    --splash_image.alpha = 0.3
    --group:insert( splash_image )



	lbl_playerInfo = display.newText( "Please provide details for high scores", 450, 50, font, 38 )
	lbl_playerInfo.x = display.contentCenterX
	lbl_playerInfo.y = display.contentCenterY - 350
	lbl_playerInfo:setTextColor( 255, 255, 255 ) 
	group:insert(lbl_playerInfo)

	lbl_playerInfo2 = display.newText( "Tap next button to save", 450, 50, font, 38 )
	lbl_playerInfo2.x = display.contentCenterX
	lbl_playerInfo2.y = display.contentCenterY - 250
	lbl_playerInfo2:setTextColor( 255, 255, 255 ) 
	group:insert(lbl_playerInfo2)

	lbl_playerInfo3 = display.newText( "Or back button to go back without saving", 450, 50, font, 38 )
	lbl_playerInfo3.x = display.contentCenterX
	lbl_playerInfo3.y = display.contentCenterY - 150
	lbl_playerInfo3:setTextColor( 255, 255, 255 ) 
	group:insert(lbl_playerInfo3)


	lbl_playerName = display.newText( "Player Name :", 250, 50, font, 36 )
	lbl_playerName.x = display.contentCenterX
	lbl_playerName.y = display.contentCenterY -50
	lbl_playerName:setTextColor( 255, 255, 255 ) 
	group:insert(lbl_playerName)

	usertextBox = native.newTextField( 200, 125, 350, 60, 32)
	usertextBox.x = display.contentCenterX 
	usertextBox.y = display.contentCenterY + 20
	usertextBox.inputType = "default"
	usertextBox.font = native.newFont(font,12)

	loadPrefs()

	if (localusername == "") then
		hintText = "Enter your name"
	else
		hintText = localusername
	end
	usertextBox.text = hintText
	usertextBox.align = "center"
	group:insert(usertextBox)


	lbl_Country = display.newText( "Country :", 250, 50, font, 36 )
	lbl_Country.x = display.contentCenterX
	lbl_Country.y = display.contentCenterY + 150
	lbl_Country:setTextColor( 255, 255, 255 )
	group:insert(lbl_Country)

	countrytextBox = native.newTextField( 200, 125, 350,60, 32)
	countrytextBox.inputType = "default"
	countrytextBox.font = native.newFont(font,12)
	countrytextBox.x = display.contentCenterX
	countrytextBox.y = display.contentCenterY + 220
	
	
	if (localusercountry == "") then
		hintText2 = "Enter your country"
	else
		hintText2 = localusercountry
	end
	countrytextBox.text = hintText2
	countrytextBox.align = "center"
	group:insert(countrytextBox)
	
	local btnSub = display.newImageRect(interface[1].nextButton, 180, 180 )
	btnSub.x = display.contentCenterX
	btnSub.y = display.contentCenterY + 400
	group:insert( btnSub )
	--retry.xScale,retry.yScale=2,2
	btnSub.alpha=1
	btnSub:addEventListener("tap",saveAndgotoMenu)


	local myYDimention = display.contentCenterY + interface[1].downButtonsDimention
	local retry = display.newImageRect(interface[1].backbutton, interface[1].soundButtonDimention, interface[1].soundButtonDimention )
    retry.x = interface[1].btnMenuX
    retry.y = topbarButtons
    group:insert( retry )
    --retry.xScale,retry.yScale=2,2
    retry.alpha=1
    retry:addEventListener("tap",gotomenu)

	background:addEventListener("tap", backgroundTap)
	usertextBox:addEventListener("userInput",userInputp)
	countrytextBox:addEventListener("userInput",userInputpp)

	--btnSub:addEventListener("tap", goToPlayHigh)

	if (withBackgroundMousic==true) then
        btnSound = display.newImageRect("images/buttons/btn_sound-sheet0.png", interface[1].soundButtonDimention, interface[1].soundButtonDimention )
        audio.stop()
        playLoopSound( theme_sound,1, -1 , 0.3)
    else 
        btnSound = display.newImageRect("images/buttons/btn_sound-sheet1.png", interface[1].soundButtonDimention, interface[1].soundButtonDimention )
        audio.stop()
    end
    btnSound.x = display.contentWidth - interface[1].soundButtonDimention--100--centerX
    btnSound.y = topbarButtons-- 20 -- display.contentHeight - 50
    group:insert(btnSound)
    --group:insert(btnSound)
    --btnSound:addEventListener("tap",changeMusic)
    btnSound:toFront()
    btnSound:addEventListener("tap",changeMusic)
			
end


-- Called when scene is about to move offscreen:
function scene:exitScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. stop timers, remove listeners, unload sounds, etc.)
	
	-----------------------------------------------------------------------------
	
end


-- Called prior to the removal of scene's "view" (display group)
function scene:destroyScene( event )
	local group = self.view
	
	-----------------------------------------------------------------------------
	
	--	INSERT code here (e.g. remove listeners, widgets, save state, etc.)
	
	-----------------------------------------------------------------------------
	
end


---------------------------------------------------------------------------------
-- END OF YOUR IMPLEMENTATION
---------------------------------------------------------------------------------

-- "createScene" event is dispatched if scene's view does not exist
scene:addEventListener( "createScene", scene )

-- "enterScene" event is dispatched whenever scene transition has finished
scene:addEventListener( "enterScene", scene )

-- "exitScene" event is dispatched before next scene's transition begins
scene:addEventListener( "exitScene", scene )

-- "destroyScene" event is dispatched before view is unloaded, which can be
-- automatically unloaded in low memory situations, or explicitly via a call to
-- storyboard.purgeScene() or storyboard.removeScene().
scene:addEventListener( "destroyScene", scene )

---------------------------------------------------------------------------------

return scene